using System;
using RootPro.RootProCAD;
using RootPro.RootProCAD.Command;
using RootPro.RootProCAD.Geometry;

///////////////////////////////////////////////////////////////////////////////////////////////////
// I̒𑪒肷AhC
// IAA̐̒𑪒肵܂Bʂ͈ꗗ\ŕ\łA̗݌vvł܂B
///////////////////////////////////////////////////////////////////////////////////////////////////

namespace RCAddInMeasureCS
{
    public partial class RootProCADApplication
    {
        string LengthCommandName = "RootPro.AddIn.LengthMesureCommand";     //R}h 
        FormResult formResult;

        /// <summary>
        /// EBhEnhJ邽߂̃C^[tFCX̎NX
        /// </summary>
        class RootProWindow : System.Windows.Forms.IWin32Window
        {
            RootProCADApplication app;

            public RootProWindow(RootProCADApplication app)
            {
                this.app = app;
            }

            /// <summary>
            /// EBhEnh擾
            /// </summary>
            public virtual System.IntPtr Handle
            {
                get { return app.WindowHandle; }
            }
        }


        /// <summary>
        /// X^[gAbv
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void RootProCADApplication_Startup(object sender, EventArgs e)
        {
            //j[ɃR}hǉ
            CommandManager.AddMacroCommand("", MacroCommand);

            //R}hǉ
            Command command = CommandManager.AddCommand(LengthCommandName, "");
   
            //p[^ǉ
            CommandParameterGroup commandParameterGroup = command.ParameterGroups.Add(ParameterItemType.Shape, 0, "}`");
            ShapeParameterItem parameterItem = (ShapeParameterItem)commandParameterGroup.CurrentItem; // p[^ACe
            parameterItem.ShapeTypeFilter = ShapeTypeFilters.Line | ShapeTypeFilters.Polyline;      //ƘÂ
            parameterItem.Description = "A͘Aw肵܂B";

            //JnCxgƏICxg̒ǉ
            command.Begin += new CommandBeginEventHandler(command_Begin);
            command.End += new EventHandler(command_End);

        }

        /// <summary>
        /// I
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void RootProCADApplication_Shutdown(object sender, EventArgs e)
        {
            //j[ɃR}hǉ
            CommandManager.RemoveCommand(LengthCommandName);
            CommandManager.RemoveMacroCommand(MacroCommand);
        }

        #region VSTA generated code
        private void InternalStartup()
        {
            this.Startup += new System.EventHandler(RootProCADApplication_Startup);
            this.Shutdown += new System.EventHandler(RootProCADApplication_Shutdown);
        }
        #endregion

        /// <summary>
        /// }NR}h̎s
        /// </summary>
        private void MacroCommand()
        {

            //R}h̎s
            CommandManager.ExecuteCommand(LengthCommandName);
        }

        /// <summary>
        /// R}h̊JnɌĂ΂
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void command_Begin(Object sender, CommandBeginEventArgs e)
        {
            Command command = (Command)sender;
            RootProWindow wnd = new RootProWindow(this);

            //tH[̍쐬
            FormResult form = new FormResult();

            //tH[\([hX)
            form.Show(wnd);

            formResult = form;


            //p[^ύXCxg̒ǉ
            command.ParameterChanged += new CommandParameterChangedEventHandler(command_ParameterChanged);
        }

        /// <summary>
        /// R}h̏IɌĂ΂
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void command_End(Object sender, EventArgs e)
        {
            Command command = (Command)sender;

            //p[^ύXCxg̍폜
            command.ParameterChanged -= new CommandParameterChangedEventHandler(command_ParameterChanged);

            //tH[͏I
            formResult.Close();

            formResult.Dispose();

            formResult = null;

        }

        /// <summary>
        /// p[^ύXCxg 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void command_ParameterChanged(Object sender, CommandParameterChangedEventArgs e)
        {
            Command command = (Command)sender;
            int id = e.ParameterID;// ύX̂p[^ID
            ParameterItem parameterItem = command.GetParameterItemByID(id); // p[^ACe


            //}`P̎擾
            ShapeParameterItem parameterItem0 = (ShapeParameterItem)command.GetParameterItemByID(0);
            if (parameterItem0.IsEmpty)
                return;

            Shape shape0 = parameterItem0.Shape.Shape;
            double length = 0.0;
            if (shape0 is LineShape)
            {
                length = ((LineShape)shape0).Length;
            }
            else if (shape0 is PolylineShape)
            {
                length = ((PolylineShape)shape0).Length;
            }

            // ʂǉ
            if( formResult != null )
                formResult.AddResult("("+shape0.Number.ToString()+")", length);

            //p[^ɂ
            parameterItem0.SetEmpty();
        }
    }
}
